;
;   Compile with FASM for Menuet
;
   
use32
   
               org    0x0
   
               db     'MENUET01'              ; 8 byte id
               dd     0x01                    ; header version
               dd     START                   ; start of code
               dd     I_END                   ; size of image
               dd     0x300000                ; memory for app
               dd     0x7fff0                 ; esp
               dd     0x0 , 0x0               ; I_Param , I_Icon
   
START:
testing:
    mov  dx,0x37a                   ; ,    
    in   al,dx                      ; 
    bt   ax,3
    jc   busy                       ;  ,   busy 
    mov  al,11001110b               ;  ,   
    out  dx,al                      ;    
    out  dx,al
    mov dword  [color],0x03008f7f   ;    
    mov dword  [posi],0             ;     
    call draw_window                ;   
    mov esi,string                  ;      
    push esi
   
still:
   
    mov  eax,11                 ;    
    int  0x40
   
    cmp  eax,1                  ;    ?
    je   red
    cmp  eax,2                  ;   ?
    je   key
    cmp  eax,3                  ;   ?
    je   button
    cmp dword [posi],280        ;    " "?
    je   testing                ;  ,    
    mov  dx,0x379               ;    ? 
    in   al,dx                  ;   - 
    in   al,dx                  ;   BUSY (   ) 
    bt   ax,4                   ;   ?
    jnc  notready
    bt   ax,5                   ;   ?  
    jc   nopaper                 
    bt   ax,3                   ; ?
    jnc  error
    bt   ax,7                    ;   BUSY?
    jnc  still
    cmp dword  [posi],0          ;    ? 
    je   print                    ; ,  
    mov dword  [color],0x03008f7f
    mov dword  [posi],0
    call draw_window              ;   
print:
    pop  esi                      ;    
    cmp  esi,string+stringlen     ;  ?
    je  close                     ;  ,   
    mov  dx,0x378                 ;     
    cld
    outsb
    push esi                      ; ,   1  
                                  ;      
    mov  dx,0x37a
    in   al,dx                    ;   
    in   al,dx
    btc  ax,0                     ;      
    out  dx,al
    out  dx,al
    btc  ax,0                     ;   
    out  dx,al
    jmp  still                    ;  
   
  red:
    call draw_window             ;   
    jmp  still
   
  key:                          ;  
    mov  eax,2                  ;     
    int  0x40
    jmp  still
   
  button:                       ;  
    mov  eax,17                 ;  id
    int  0x40
   
    cmp  ah,1                   ;   1 ?
    jne  noclose                ;  - ,  -  
 close:
    cmp dword [posi],280        ;     ""?
    je   close1                 ;  ,  ,  -
    mov  dx,0x37a               ;  0   SEL ( )  
    mov  al,11000110b           ;    
    out  dx,al
close1:
    mov  eax,-1                 
    int  0x40
  noclose:                       ;    ,  
   
    jmp  still
   
notready:
    cmp dword  [posi],70         ;    ?
    je   still
    mov dword  [color],0x03b00000
    mov dword  [posi],70
    call draw_window              ; 
    call delay_red                ;  
    jmp still                      
   
nopaper:                          ; 
    bt   ax,3                     ;    error?
    jc   notready                 ;  ,    
    cmp dword  [posi],140
    je   still
    mov dword  [color],0x03d0c000
    mov dword  [posi],140
    call draw_window
    call delay_red
    jmp still
   
error:
    cmp dword [posi],210
    je   still
    mov dword [color],0x03b00000
    mov dword [posi],210
    call draw_window
    call delay_red
    jmp still
   
busy:
    cmp dword [posi],280
    je   still
    mov dword  [color],0x03d0c000
    mov dword  [posi],280
    call draw_window
    call delay_red
    jmp still
   
;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
   
delay_red:             
    mov  eax,5
    mov  ebx,50
    int  0x40
    ret
   
   
draw_window:
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,1                     ; 1, start of draw
    int  0x40
   
                                   ; DRAW WINDOW
    mov  eax,0                     ; function 0 : define and draw window
    mov  ebx,100*65536+300         ; [x start] *65536 + [x size]
    mov  edx,[color]               ; color of work area RRGGBB,8->
    mov  ecx,100*65536+120         ; [y start] *65536 + [y size]
    int  0x40
   
    mov  edx,[posi]                ; WINDOW LABEL
    mov  eax,4                     ; function 4 : write text to window
    mov  ebx,8*65536+8             ; [x start] *65536 + [y start]
    mov  ecx,0x10ddeeff            ; font 1 & color ( 0xF0RRGGBB )
    add  edx,text1                 ; pointer to text beginning
   
    mov  esi,30                    ; text length
    int  0x40
   
    mov  ebx,20*65536+35           ; draw info text with function 4
    mov  ecx,0x10ddeeff
    add  edx,30
    mov  esi,40
    int  0x40
   
    mov  eax,12                    ; function 12:tell os about windowdraw
    mov  ebx,2                     ; 2, end of draw
    int  0x40
   
    ret
   
   
; DATA AREA
color:  dd 0x0
posi:   dd 0
text1:
    db 'PRINTING...                    PRINTING...                            '
    db 'PRINTER - NOT READY            NO PRINTER OR THE PRINTER IS OFF       '
    db 'PRINTER - NO PAPER             NO PAPER IN PRINTER, PLEASE INSERT     '
    db 'PRINTER - ERROR                ERROR OF PRINTER                       '
     db 'PRINTER - BUSY                 THE PRINTER IS BUSY, PLEASE WAIT...    '
 string:
    db 27,64,27,120,1,27,119,1,27,87,1,'MenuetOS',27,87,0,10,10
    db '⮢ ࠭ ',27,119,0,10
    db '᫨  㤠   ᢥ,  ࠩ ਭ',10
    db 'ࠡ⠥ ࠢ쭮',10
    db 27,87,1,'   ਭ',27,87,0,10
    db 27,69,' ',27,70,10
    db 27,45,1,'ભ ',27,45,0,10
    db 27,52,'ᨢ',27,53,10
    db ' ⮢ ࠭ 祭. .ᮢ lisovin@26.ru',12
   
stringlen:
sost:  dd 0b
   
I_END:
   
   
   
   